t.me/atinfo_chat Telegram группа по автоматизации тестирования

[AppClassLoader@6ed3ef1] warning javax.* types are not being woven because the weaver option '-Xset:weaveJavaxPackages=true' has not been specified

java
testng
webdriver
maven
selenium
Теги: #<Tag:0x00007f9c46847710> #<Tag:0x00007f9c468475d0> #<Tag:0x00007f9c46847490> #<Tag:0x00007f9c46847350> #<Tag:0x00007f9c468471e8>

(Necrosium) #1

Java + TestNG + maven

ошибка в консоле:

[AppClassLoader@6ed3ef1] warning javax.* types are not being woven because the weaver option ‘-Xset:weaveJavaxPackages=true’ has not been specified

Последний раз, несколько дней назад, когда появилась эта проблема, в проекте происходила какая-то магия: не работали методы, которые были настроены и полностью работоспособны + при дебаге не ставились брейкпоинты на исполняемые строки кода, idea подсвечивала их как неисполняемые.
чуть погуглив (полного разбора полетов по данной проблеме мне так и не удалось найти), я увидел, что многие ссылались на aspectj
мне удалось ее решить обновив в поме версию aspectj и мистические проблемы с методами и брейкпоинтами исчезли вместе с ошибкой, но, спустя несколько дней эта ошибка снова появилась. Правда на данный момент, явных проблем в исполнении тестов я не вижу.

гугл выдает достаточно мало инфы касаемо этой проблемы (в особенности в связке с автотестами)
Поделитесь пожалуйста опытом и объясните, что это за проблема, в чем суть и как с ней бороться

pom
<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>project</groupId>
    <artifactId>project</artifactId>
    <version>1.0-SNAPSHOT</version>

    <properties>
        <aspectj.version>1.9.4</aspectj.version>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
    </properties>
    <build>
    <plugins>
    <plugin>
        <groupId>org.codehaus.mojo</groupId>
        <artifactId>versions-maven-plugin</artifactId>
        <version>2.7</version>
        <configuration>
            <generateBackupPoms>false</generateBackupPoms>
        </configuration>
    </plugin>
    <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-compiler-plugin</artifactId>
        <version>3.8.0</version>
        <configuration>
            <source>8</source>
            <target>8</target>
        </configuration>
    </plugin>
       <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-surefire-plugin</artifactId>
            <version>3.0.0-M3</version>
            <configuration>
                <properties>
                    <allure.results.directory>allure-results</allure.results.directory>
                </properties>
                <argLine>
                    -javaagent:"${settings.localRepository}/org/aspectj/aspectjweaver/${aspectj.version}/aspectjweaver-${aspectj.version}.jar"
                </argLine>
            </configuration>
        </plugin>
    <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-failsafe-plugin</artifactId>
        <version>3.0.0-M3</version>
    </plugin>
    </plugins>
    </build>


    <dependencies>
        <dependency>
            <groupId>org.seleniumhq.selenium</groupId>
            <artifactId>selenium-server</artifactId>
            <version>3.141.59</version>
        </dependency>
        <dependency>
            <groupId>org.testng</groupId>
            <artifactId>testng</artifactId>
            <version>7.0.0-beta3</version>
            <scope>compile</scope>
        </dependency>
        <dependency>
            <groupId>commons-io</groupId>
            <artifactId>commons-io</artifactId>
            <version>2.6</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>com.mashape.unirest</groupId>
            <artifactId>unirest-java</artifactId>
            <version>1.4.9</version>
        </dependency>
        <dependency>
            <groupId>org.apache.httpcomponents</groupId>
            <artifactId>httpclient</artifactId>
            <version>4.5.6</version>
        </dependency>
        <dependency>
            <groupId>org.apache.httpcomponents</groupId>
            <artifactId>httpasyncclient</artifactId>
            <version>4.1.4</version>
        </dependency>
        <dependency>
            <groupId>org.apache.httpcomponents</groupId>
            <artifactId>httpmime</artifactId>
            <version>4.5.6</version>
        </dependency>
        <dependency>
            <groupId>org.json</groupId>
            <artifactId>json</artifactId>
            <version>20180813</version>
        </dependency>
        <dependency>
            <groupId>com.sun.mail</groupId>
            <artifactId>javax.mail</artifactId>
            <version>1.6.2</version>
        </dependency>
        <dependency>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-surefire-report-plugin</artifactId>
            <version>3.0.0-M3</version>
            <type>maven-plugin</type>
        </dependency>
        <dependency>
            <groupId>io.qameta.allure</groupId>
            <artifactId>allure-testng</artifactId>
            <version>2.9.0</version>
        </dependency>
        <dependency>
            <groupId>org.aspectj</groupId>
            <artifactId>aspectjweaver</artifactId>
            <version>1.9.4</version>
        </dependency>
        <!--LOGS-->
        <dependency>
            <groupId>org.slf4j</groupId>
            <artifactId>slf4j-api</artifactId>
            <version>1.7.5</version>
        </dependency>
        <dependency>
            <groupId>org.slf4j</groupId>
            <artifactId>slf4j-log4j12</artifactId>
            <version>1.7.5</version>
        </dependency>
        <dependency>
            <groupId>log4j</groupId>
            <artifactId>log4j</artifactId>
            <version>1.2.17</version>
        </dependency>
        <!-- END OF LOGS -->
        <dependency>
        <groupId>javax.xml.bind</groupId>
        <artifactId>jaxb-api</artifactId>
        <version>2.4.0-b180830.0359</version>
        </dependency>
        <dependency>
            <groupId>org.jetbrains</groupId>
            <artifactId>annotations</artifactId>
            <version>17.0.0</version>
            <scope>compile</scope>
        </dependency>
        <!-- VIDEO RECORDER -->
        <dependency>
            <groupId>org.monte</groupId>
            <artifactId>monte-screen-recorder</artifactId>
            <version>0.7.7</version>
        </dependency>
        <!-- HAR DATA -->
        <dependency>
            <groupId>net.lightbody.bmp</groupId>
            <artifactId>browsermob-core</artifactId>
            <version>2.1.5</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>io.qameta.allure</groupId>
            <artifactId>allure-java-commons</artifactId>
            <version>2.9.0</version>
        </dependency>
    </dependencies>

</project>

(Necrosium) #2

UP!

никто не использует aspectj в связке с allure ?? есть подозрения что проблема связана с этим…


(Vasiliy Rakshin) #3
  1. Попробуйте откатиться на 2.22.* версию.
  2. Это же варнинг, а не ошибка, в чём конкретно проблема-то?

(Necrosium) #4

на данный момент проблемы нет, но как я выше писал, были какие-то необъяснимые глюки, и они пропали, после того, как я обновил aspectj и этот варнинг тоже пропал, вместе с обновлением, на некоторое время.

тут уже дело больше в интересе. Есть ли какой-то способ явно указать опцию Xset:weaveJavaxPackages=true ?
если да, то подскажите, где это можно сделать ?


(Vasiliy Rakshin) #5

В свойствах проекта смотрите, или в настройках Java виртуальной машины.


Например на скрине - поле VM Options.